'=============================================================
' Patch TB2k & TBX.vbs - WSH script for patching TB2k and TBX.
' Version 1.8
' Copyright (c) 2006 Vladimir Bochkarev <boxa@mail.ru>
'=============================================================

dim CurPath, oShellApp, oShell, oFS, IsNT

const TB2k_PatchName = "_tb2k_2.2.1_patch"
const TB2k_Files = "TB2\*.dfm"
const TBX_PatchName = "_tbx_2.1.beta_patch"
const TBX_Files1 = "TBX\*.dcr"
const TBX_Files2 = "TBX\*.res"

Initialize
DoPatching

sub Initialize
  dim oSysEnv
  CurPath = Left(WScript.ScriptFullName, Len(WScript.ScriptFullName)- Len(WScript.ScriptName))
  set oFS = CreateObject("Scripting.FileSystemObject")
  set oShellApp = CreateObject("Shell.Application")
  set oShell = WScript.CreateObject("WScript.Shell")
  set oSysEnv = oShell.Environment("SYSTEM")
  IsNT = oSysEnv("OS") = "Windows_NT"
end sub

function GetFolderObj(TitleText)
  const ssfDRIVES = 17
  set GetFolderObj = oShellApp.BrowseForFolder(0, TitleText, 0, ssfDRIVES)
end function

sub DoPatching
  const Yes = 6
  dim oFolder, BtnCode

  ' TB2K
  set oFolder = GetFolderObj("Choose a TB2K *SOURCE* folder" & Chr(13) & "(for example: C:\TB2\Source)")
  if oFolder is nothing then
    BtnCode = oShell.Popup("Do you wish to interrupt patching?", 30,, 4+32)
    if BtnCode = Yes then Exit Sub
  else
    call Copy(oFolder, "", TB2k_Files)
    call CopyAndPatch(oFolder, "TB2", TB2k_PatchName)
  end if

  ' TBX
  set oFolder = GetFolderObj("Choose a TBX folder (for example: C:\TBX)")
  if oFolder is nothing then
    BtnCode = oShell.Popup("Do you wish to interrupt patching?", 30,, 4+32)
    if BtnCode = Yes then Exit Sub
  else
    call Copy(oFolder, "", TBX_Files1)
    call Copy(oFolder, "Packages", TBX_Files2)
    call CopyAndPatch(oFolder, "TBX", TBX_PatchName)
  end if

  call oShell.Popup("All Done!", 30,, 0+64)
end sub

sub Copy(oBaseFolder, SubFolder, FileName)
  dim FullName
  FullName = CurPath & FileName
  if SubFolder <> "" then
    dim oFItem
    oBaseFolder.NewFolder(SubFolder)
    set oFItem = oBaseFolder.ParseName(SubFolder)
    if oFItem is nothing then
      call oShell.Popup("Error! Folder: " & SubFolder & " not found.", 30,, 0+48)
    else
      oFItem.GetFolder.CopyHere(FullName)
    end if
  else
    oBaseFolder.CopyHere(FullName)
  end if
end sub

sub CopyAndPatch(oFolder, SubFolder, PatchName)
  dim PathName, CommProc

  oFolder.CopyHere(CurPath & "Common\patch.bat")
  oFolder.CopyHere(CurPath & "Common\patch.exe")
  oFolder.CopyHere(CurPath & SubFolder & "\" & PatchName & ".diff.txt")

  PathName = oFolder.Items.Item.Path
  if IsNT then
    CommProc = "cmd"
  else
    CommProc = "command"
  end if
  oShell.Run(CommProc & " /K " & "Common\patch.bat " & PatchName & ".diff.txt " _
    & Left(PathName, 2) & " " & """" & PathName & """")
  WScript.Sleep(300)
end sub
